#include "mygba.h"
#include <math.h>
#include <stdlib.h>
#include "bg.c"
#include "pics/ball.h"
#include "pics/paddle.h"
#include "pics/bricks.h"
#define SECOND 16386

//**************************************************************************
//**   Global Variables and Functions that don't require class definitions
//**************************************************************************

int number_of_balls = 10;
u8 begin_ball_movement = 0;
u8 living = 1;
u8 won = 0;
u8 Map[20][30] = {
{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,6},
{6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,6,6}};

void change_starting_angle(int);
//*********************************
//**   Paddle class and functions
//*********************************

class Paddle {
private:
	int paddlex, newpaddlex;
	u8 mvt, ObjPaddle;
	u8 CheckWalls();
public:
	Paddle() {};// do nothing as paddle is a global
	~Paddle() { ham_DeleteObj(ObjPaddle); };
	void init();
	void move();
	void query_keys();
	int GetEdge() { return paddlex; };
};

void Paddle::init() {
	ObjPaddle = ham_CreateObj((void *)&paddleData[0],1,1,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,104,152);
	paddlex = 104;
	newpaddlex = paddlex;
}

void Paddle::move() {
	if (CheckWalls() == 1) {	// outside border; don't move
		newpaddlex = paddlex;
	} else {
		paddlex = newpaddlex;
		ham_SetObjX(ObjPaddle, paddlex);
		ham_SetObjY(ObjPaddle, 152);
		ham_UpdateObjGfx(ObjPaddle, (void *)&paddleData[0]);
	}
}

void Paddle::query_keys() {
	if ((number_of_balls < 0) || (won == 1)) {
		return;
	} else if (F_CTRLINPUT_A_PRESSED && begin_ball_movement == 0) {	// user pushes "A" button
		while (F_CTRLINPUT_A_PRESSED) {}	// wait till they let go of it
		begin_ball_movement = 1;
	} else if (F_CTRLINPUT_B_PRESSED) {	//user pushes "B" button
	} else if (F_CTRLINPUT_L_PRESSED && (begin_ball_movement == 0)) {	//user pushes "L" button
	   while (F_CTRLINPUT_L_PRESSED) {}
	   if (begin_ball_movement == 0) { // makes sure the ball hasn't started moving before user lets go of button
	       change_starting_angle(45);
       }
	} else if (F_CTRLINPUT_R_PRESSED && (begin_ball_movement == 0)) {	//user pushes "R" button
	   while (F_CTRLINPUT_R_PRESSED) {}
	   if (begin_ball_movement == 0) { // makes sure the ball hasn't started moving before user lets go of button
	       change_starting_angle(-45);
        }
	} else if (F_CTRLINPUT_START_PRESSED && begin_ball_movement == 0) { // user pushes start button
		while (F_CTRLINPUT_START_PRESSED) {}	// wait till they let go of it
		begin_ball_movement = 1;
	} else if (F_CTRLINPUT_UP_PRESSED) {	// user presses UP
	} else if (F_CTRLINPUT_DOWN_PRESSED) {	// user presses DOWN
	} else if (F_CTRLINPUT_LEFT_PRESSED && !F_CTRLINPUT_UP_PRESSED && !F_CTRLINPUT_DOWN_PRESSED) { // && game_paused == 0
		// user pushes "LEFT" only
		newpaddlex = paddlex - 1;
		mvt = 1;
		return;
	} else if (F_CTRLINPUT_RIGHT_PRESSED && !F_CTRLINPUT_UP_PRESSED && !F_CTRLINPUT_DOWN_PRESSED) { // && game_paused == 0
		// user pushes "RIGHT" only
		newpaddlex = paddlex + 1;
		mvt = 1;
		return;
	}
	mvt = 0;
}

u8 Paddle::CheckWalls() {
	if ((newpaddlex > 192) || (newpaddlex < 16))
		return 1;
	return 0;
}

//***************************************
//**   Define Global Instance of Paddle
//***************************************

Paddle p;

//********************************
//**   Brick class and functions
//********************************

class Brick {
private:
	int color;
	int leftx, bottomy, rightx, topy; // coordinates of brick
	u8 Obj1;
public:
	Brick(int x, int y); // constructor, default color = 1 (yellow)
	Brick(int x, int y, int c);
	~Brick() { ham_DeleteObj(Obj1); };		// destructor
	void explode();
	void redraw();
	bool IsVerticalBounce(int,int,int,int);
};

Brick::Brick(int x, int y) {
	color = 1;
	leftx = 32 + x*16;
	rightx = 48 +x*16;
	bottomy = 88 - y*8;
	topy = 80 - y*8;
	Map[topy/8][leftx/8] = 1;
	Map[topy/8][leftx/8+1] = 1;
	Obj1 = ham_CreateObj((void *)&bricksData[(color-1)*64],1,0,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,leftx,topy);
}

Brick::Brick(int x, int y, int c) {
	color = c;
	leftx = 32 + x*16;
	rightx = 48 +x*16;
	bottomy = 88 - y*8;
	topy = 80 - y*8;
	Map[topy/8][leftx/8] = c;
	Map[topy/8][leftx/8+1] = c;
	Obj1 = ham_CreateObj((void *)&bricksData[(color-1)*64],1,0,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,leftx,topy);
}

void Brick::explode() {
    if (Map[topy/8][leftx/8] > 0) {
        Map[topy/8][leftx/8] --;
    } else {
        Map[topy/8][leftx/8] = 0;
    }
	Map[topy/8][leftx/8+1] = Map[topy/8][leftx/8];
    color = Map[topy/8][leftx/8];
}

void Brick::redraw() {
    if (Map[topy/8][leftx/8] <= 0) {
        ham_SetObjVisible(Obj1, 0);
    } else {
        ham_SetObjVisible(Obj1, 1);
        ham_UpdateObjGfx(Obj1,(void *)&bricksData[(Map[topy/8][leftx/8]-1)*64]);
    }
}

bool Brick::IsVerticalBounce(int nextx, int nexty, int oldx, int oldy) {
	double m1 = (nexty-oldy)/(nextx-oldx);	// slope of incoming ball
	double b1 = nexty - m1*nextx;				// intercept of incoming ball
	double top_possible = (topy - b1) / m1;
	double bottom_possible = (bottomy - b1) / m1;
	double left_possible = m1*leftx + b1;
	
	if ((top_possible <= rightx) && (top_possible >= leftx) &&
      (((top_possible <= oldx) && (top_possible >= nextx)) ||
      ((top_possible >=oldx) && (top_possible <= nextx)))){ // hit along the top
		return false;
	} else if ((bottom_possible <= rightx) && (bottom_possible >= leftx) &&
      (((bottom_possible <= oldx) && (bottom_possible >= nextx)) ||
      ((bottom_possible >= oldx) && (bottom_possible <= nextx)))) { // hit along the bottom
		return false;
	} else if ((left_possible >= topy) && (left_possible <= bottomy) &&
      (((left_possible <= nexty) && (left_possible >= oldy)) ||
      ((left_possible >= nexty) && (left_possible <= oldy)))) { // hit on the left side
		return true;
	} else { // hit on the right side
		return true;
	}
}

//*******************************
//**   Ball class and functions
//*******************************

class Ball {
    friend void change_starting_angle(int);
private:
	int posx, posy, newx, newy, speed, test;
	bool ul, ur, ll, lr; // which corner I'm referencing
	Brick *barray[11][7];
	int angle; // angle is in degrees
	double percent_distance_remaining;
	u8 ObjBall;
	bool finished_moving, vertical_bounce_off_brick;
	void verifyvals();
	void horizontalbounce();
	void verticalbounce();
	void paddlebounce(int);
	void brickbounce();
	u8 CheckMap();
	void reinit();
	void redraw_ball();
	void brickexplode(Brick &);
	void where_are_we_going();
	void continue_moving();
	void get_new_coords(double);
	void change_paddle_angle(int);
	bool VerticalThrust(int,int);
	void check_for_completion();
public:
	Ball() {}; // Do nothing here.  Ball created outside of usable space
	~Ball() { ham_DeleteObj(ObjBall); };
	void init();
	void move();
	void load_brick_array(Brick *array[11][7]);
};

void Ball::init() {
	posx = 115;
	posy = 120;
	newx = posx;
	newy = posy;
	speed = 1;
	angle = 45;
	finished_moving = true;
	ObjBall = ham_CreateObj((void *)&ballData[0],0,0,OBJ_MODE_NORMAL,1,0,0,0,0,0,0,posx,posy);
}

void Ball::reinit() {
	posx = 115;
	posy = 120;
	newx = posx;
	newy = posy;
	speed = 1;
	angle = 45;
	finished_moving = true;
	redraw_ball();
}

void Ball::load_brick_array(Brick *array[11][7]) {
	for (int i=0; i<11; i++) {
		for (int j=0; j<7; j++) {
			barray[i][j] = array[i][j];
		}
	}
}

void Ball::check_for_completion() {
    bool bricks_left = false;
    for (int i=4; i<11; i++) {
        for (int j=4; j<26; j++) {
            if (Map[i][j] != 0) {
                bricks_left = true;
            }
        }
    }
    if (!bricks_left) {
        won = 1;
    }
}

void Ball::move() {
	ham_CopyObjToOAM(); // copy sprites to memory
	
	if (begin_ball_movement == 0) { // haven't started moving yet
		return;
	} else if (!finished_moving) {
		return;
	}
	finished_moving = false;
	percent_distance_remaining = 0;
	get_new_coords(1);
	where_are_we_going();
}

void Ball::get_new_coords(double scale) {
    if (angle%90 == 0) {
        if (angle == 90) {
            newx = posx;
            newy = posy - (int)scale*speed;
        } else if (angle == 180) {
            newx = posx - (int)scale*speed;
            newy = posy;
        } else if (angle == 270) {
            newx = posx;
            newy = posy + (int)scale*speed;
        } else {
            newx = posx + (int)scale*speed;
            newy = posy;
        }
    } else if (angle%45 == 0) {
        if ((angle == 45) || (angle == 315)) {
            newx = posx + (int)scale*speed;
        } else  {
            newx = posx - (int)scale*speed;
        }
        if ((angle == 45) || (angle == 135)) { // appears backwards b/c y runs from top to bottom instead of vice versa
            newy = posy - (int)scale*speed;
        } else {
            newy = posy + (int)scale*speed;
        }
    } else {
        switch (angle) {
        case 30:
            newx = posx + (int)scale*2*speed;
            newy = posy - (int)scale*speed;
            break;
        case 60:
            newx = posx + (int)scale*speed;
            newy = posy - (int)scale*2*speed;
            break;
        case 120:
            newx = posx - (int)scale*speed;
            newy = posy - (int)scale*2*speed;
            break;
        case 150:
            newx = posx - (int)scale*2*speed;
            newy = posy - (int)scale*speed;
            break;
        case 210:
            newx = posx - (int)scale*2*speed;
            newy = posy + (int)scale*speed;
            break;
        case 240:
            newx = posx - (int)scale*speed;
            newy = posy + (int)scale*2*speed;
            break;
        case 300:
            newx = posx + (int)scale*speed;
            newy = posy + (int)scale*2*speed;
            break;
        default: // 330 degrees
            newx = posx + (int)scale*2*speed;
            newy = posy + (int)scale*speed;
            break;
        };
    }
}

void Ball::where_are_we_going() {
	int left_paddle_edge;
	test = CheckMap();
	if ((newx < 16) || (newx > 216)) {	// Wall in the way
		verticalbounce();
	} else if (test == 5) {	//Ceiling in the way
		horizontalbounce();
	} else if (test == 8) {	// off bottom of screen => death
		number_of_balls --;
		begin_ball_movement = 0;
		reinit();
	} else if (newy >= 146) { // Possible paddle hit
		left_paddle_edge = p.GetEdge();
		if ((newx >= left_paddle_edge) && (newx <= (left_paddle_edge + 32))) { // hit paddle
			paddlebounce(left_paddle_edge);
		} else { // missed paddle
			posx = newx;
			posy = newy;
			redraw_ball();
		}
	} else if (test <= 0) {	// Nothing in way; actually move
		posx = newx;
		posy = newy;
		redraw_ball();
	} else {	// Hit a brick
		brickbounce();
	}
}

void Ball::redraw_ball() {
	ham_SetObjX(ObjBall, posx);
	ham_SetObjY(ObjBall, posy);
	ham_UpdateObjGfx(ObjBall, (void *)&ballData[0]);
	finished_moving = true;
}

void Ball::continue_moving() {
	int m, b;
	double length = sqrt((newy-posy)^2 + (newx-posx)^2);
	
	if ((newx-posx) !=0) { m = (newy - posy) / (newx - posx); }
	else { m = 999; }
	b = newy - m*newx;
	
	if (test == 5) { // Ceiling
		posy = 16;
		if (m != 999) {   // if m = 999, then posx=newx, so no change is needed
            posx  = (posy - b)/m;
        }
	} else if ((newx < 16) || (newx > 216)) { // Wall
		if (posx > 120) { posx = 216; }
		else { posx = 16; }
		posy = m*posx + b;
	} else if (newy >=146) { // Paddle
		posy = 145;
		if (m != 999) {
            posx = (posy - b)/m;
        }
	} else { // Brick
		if (vertical_bounce_off_brick) {
			if (posx > newx) {
				posx = ((int)(posx/8))*8;
			} else {
				posx = ((int)(newx/8))*8;
			}
            if (m != 999) {
                posy = m*posx + b;
            } else {
                posy -= speed;
            }
		} else {
			if (posy > newy) {
				posy = ((int)(posy/8))*8;
			} else {
				posy = ((int)(newy/8))*8;
			}
            if (m != 999) {
                posx = (posy - b)/m;
            }
		}
	}
	percent_distance_remaining = 1 - sqrt((newy-posy)^2 + (newx-posx)^2)/length - percent_distance_remaining;
	if (percent_distance_remaining < 1) {
	    get_new_coords(percent_distance_remaining);
		where_are_we_going();
	} else {
		redraw_ball();
	}
}

void Ball::horizontalbounce() {
	angle = 360 - angle;
	verifyvals();
	continue_moving();
}

void Ball::verticalbounce() {
	angle = 180 - angle;
	if (angle == 90) { angle = 270; } // finishing the computation
	else if (angle == -90) { angle = 90; }
	verifyvals();
	continue_moving();
}

void Ball::paddlebounce(int left_paddle_edge) {
	int left_edge, right_edge, correspondingx;
	left_edge = left_paddle_edge + 8;
	right_edge = left_paddle_edge + 24;
	correspondingx = newx;
	angle = 360 - angle;
	if (correspondingx <= left_edge) {	// hit left side of paddle
		if (angle <= 270 )	// third quadrant vector
			speed ++;
		else	// fourth quadrant vector
			speed --;
		change_paddle_angle(45);
	} else if (correspondingx >= right_edge) { // hit right side of paddle
		if (angle <= 270 )	// third quadrant vector
			speed --;
		else	// fourth quadrant vector
			speed ++;
		change_paddle_angle(-45);
	} else {
        verifyvals();
    }
	continue_moving();
}

void Ball::change_paddle_angle(int amount) {
    angle += amount;
    verifyvals();
}

void Ball::brickbounce() {
	int tempx, tempy, placex, placey;
	if (ul) { // upper left corner of the ball
	    placex = newx;
	    placey = newy;
        tempy = (88 - placey)/8;
    } else if (ur) { // upper right corner of the ball
        placex = newx + 8;
	    placey = newy;
        tempy = (88 - placey)/8;
    } else if (ll) { // lower left corner of the ball
        placex = newx;
	    placey = newy + 8;
	    if (VerticalThrust(placex, placey)) {
	        tempy = (80 - placey)/8;
        } else {
            tempy = (88 - placey)/8;
        }
    } else { // lower right corner of ball
        placex = newx + 8;
        placey = newy + 8;
	    if (VerticalThrust(placex, placey)) {
	        tempy = (80 - placey)/8;
        } else {
            tempy = (88 - placey)/8;
        }
    }
	tempx = (placex - 32)/16;
	brickexplode(*barray[tempx][tempy]);
}

bool Ball::VerticalThrust(int noobx, int nooby) {
    if (angle < 180) {
        return false;
    } else {
        if (Map[(nooby)/8][(noobx)/8] != Map[(nooby-speed)/8][(noobx)/8]) {
            return true;
        } else {
            return false;
        }
    }
}

void Ball::brickexplode(Brick &temp) {
    int tempnewx, tempposx, tempnewy, tempposy;
	temp.explode();
    check_for_completion();
	if (ul) {
	    tempnewx = newx;
	    tempnewy = newy;
	    tempposx = posx;
	    tempposy = posy;
    } else if (ur) {
	    tempnewx = newx + 8;
	    tempnewy = newy;
	    tempposx = posx + 8;
	    tempposy = posy;
    } else if (ll) {
	    tempnewx = newx;
	    tempnewy = newy + 8;
	    tempposx = posx;
	    tempposy = posy + 8;
    } else {
	    tempnewx = newx + 8;
	    tempnewy = newy + 8;
	    tempposx = posx + 8;
	    tempposy = posy + 8;
    }
	if (temp.IsVerticalBounce(tempnewx,tempnewy,tempposx,tempposy)) {
		vertical_bounce_off_brick = true;
		verticalbounce();
	} else {
		vertical_bounce_off_brick = false;
		horizontalbounce();
	}
}

void Ball::verifyvals() {
    while (angle < 0) {	// while loop to make sure that it's between 0 and 360
		angle += 360;
	}
	while (angle >= 360) {	// ditto
		angle -= 360;
	}
	
	if (angle == 0) {
	    angle = 45;
    } else if (angle == 180) {
        angle = 135;
    }
	
	if (speed < 1) { speed = 1;	}
	else if (speed > 8) { speed = 8; } // maximum speed is 8 so the ball only goes through one brick at a time
}

u8 Ball::CheckMap() {
	if ((newy > 20*8) || (newy < 8) || (newx < 8) || (newx > 29*8)) { // gone off the screen and died
		return 8;
	}
    if (newy > 120) {
        return Map[newy/8][newx/8];
    }
    if (angle < 180) {
        if (Map[(newy)/8][(newx+8)/8] == 0) {
            if (Map[(newy)/8][(newx)/8] == 0) {
                if (Map[(newy+8)/8][(newx)/8] == 0) {
                    if (Map[(newy+8)/8][(newx+8)/8] == 0) {
                        ul = true; // just make sure one of them is true
                        return 0;
                    } else { // use lower right
                        lr = true;
                        ll = false;
                        ul = false;
                        ur = false;
                        return Map[(newy+8)/8][(newx+8)/8];
                    }
                } else { // use lower left
                    ll = true;
                    ul = false;
                    lr = false;
                    ur = false;
                    return Map[(newy+8)/8][(newx)/8];
                }
            } else { // use upper left
                ul = true;
                lr = false;
                ll = false;
                ur = false;
                return Map[(newy)/8][(newx)/8];
            }
        } else { // use upper right
            ur = true;
            ll = false;
            ul = false;
            lr = false;
            return Map[(newy)/8][(newx+8)/8];
        }
    } else {
        if (Map[(newy+8)/8][(newx+8)/8] == 0) {
            if (Map[(newy+8)/8][(newx)/8] == 0) {
                if (Map[(newy)/8][(newx)/8] == 0) {
                    if (Map[(newy)/8][(newx+8)/8] == 0) {
                        ul = true; // just make sure one of them is true
                        return 0;
                    } else { // use upper right
                        ur = true;
                        ll = false;
                        ul = false;
                        lr = false;
                        return Map[(newy)/8][(newx+8)/8];
                    }
                } else { // use upper left
                    ul = true;
                    ll = false;
                    lr = false;
                    ur = false;
                    return Map[(newy)/8][(newx)/8];
                }
            } else { // use lower left
                ll = true;
                lr = false;
                ul = false;
                ur = false;
                return Map[(newy+8)/8][(newx)/8];
            }
        } else { // use lower right
            lr = true;
            ll = false;
            ul = false;
            ur = false;
            return Map[(newy+8)/8][(newx+8)/8];
        }
    }
}

//**************************************************************
//**  Global Confusion Functions and more variable definitions
//**************************************************************
Ball b;

void dummy() {
	b.move();
	p.move();
}

void change_starting_angle(int amount) {
    b.angle += amount;
    if ((b.angle == 0) && (amount < 0)) {
        b.angle = 315;
    } else if ((b.angle == 180) && (amount > 0)) {
        b.angle = 225;
    }
    b.verifyvals();
}

void redraw_caller(Brick &brickarray) {
    brickarray.redraw();
}

//********************
//**   Main function
//********************

int main() {
	ham_Init();
	ham_ResetBg();
	ham_SetBgMode(0);
	Brick *barray[11][7]; // does not call constructor yet
	map_fragment_info_ptr mymap;
	ham_LoadBGPal(&bg_Palette, 256);
	ham_bg[1].ti = ham_InitTileSet(&bg_Tiles, SIZEOF_16BIT(bg_Tiles),1,1);
	ham_bg[1].mi = ham_InitMapEmptySet(3,0);
	mymap = ham_InitMapFragment(&bg_Map,30,20,0,0,30,20,0);
	ham_InsertMapFragment(mymap,1,0,0);
	ham_InitBg(1,1,0,0);
	ham_LoadObjPal(&bricksPalette, 256);
	b.init();
	p.init();
	// layout for first screen
	for (int i=0; i<11; i++) {
		for (int j=0; j<7; j++) { 
			if (i > 7) {
				barray[i][j] = new Brick(i,j);
			} else if (j == 3) {
				if ((i == 3) || (i == 4)) {
					// start calling constructors here to establish different colors for different bricks
					barray[i][j] = new Brick(i,j,4);
				} else if ((i == 2) || (i == 5)) {
					barray[i][j] = new Brick(i,j,3);
				} else if ((i == 1) || (i == 6)) {
					barray[i][j] = new Brick(i,j,2);
				} else {
					barray[i][j] = new Brick(i,j);
				}
			} else if ((j == 2) || (j == 4)){
				if ((i == 3) || (i == 4)) {
					barray[i][j] = new Brick(i,j,3);
				} else if ((i == 2) || (i == 5)) {
					barray[i][j] = new Brick(i,j,2);
				} else {
					barray[i][j] = new Brick(i,j);
				}
			} else if ((j == 1) || (j == 5)) {
				if ((i == 3) || (i == 4)) {
					barray[i][j] = new Brick(i,j,2);
				} else {
					barray[i][j] = new Brick(i,j);
				}
			} else {
				barray[i][j] = new Brick(i,j);
			}
		}
	}
	b.load_brick_array(barray);

	ham_StartIntHandler(INT_TYPE_VBL,(void *)&dummy);

	while ((number_of_balls >= 0) && (won == 0)) {
		p.query_keys();
		for (int i = 0; i < 11; i++) {
		    for (int j = 0; j < 7; j++) {
                redraw_caller(*barray[i][j]);
            }
        }
	}

	ham_StopIntHandler(INT_TYPE_VBL);

	delete [] barray;
	return 0;
}
